package eu.mhsl.craftattack.spawn.varo.appliances.tooling.adminInvisibility;

import eu.mhsl.craftattack.spawn.core.Main;
import eu.mhsl.craftattack.spawn.core.appliance.Appliance;
import net.kyori.adventure.text.Component;
import org.bukkit.Bukkit;
import org.bukkit.entity.Player;
import org.bukkit.event.Listener;
import org.bukkit.event.player.PlayerJoinEvent;
import org.jetbrains.annotations.NotNull;

import java.util.List;

public class AdminInvisibility extends Appliance {
    public void updateVisibility(PlayerJoinEvent event) {
        Player target = event.getPlayer();
        boolean shouldBeHidden = target.isOp();
        for (Player viewer : Bukkit.getOnlinePlayers()) {
            if (viewer.equals(target)) continue;

            if (shouldBeHidden) {
                viewer.hidePlayer(Main.instance(), target);
            } else {
                viewer.showPlayer(Main.instance(), target);
            }
        }

        if(shouldBeHidden) {
            target.playerListName(Component.empty());
            event.joinMessage(null);
        }
    }


    @Override
    protected @NotNull List<Listener> listeners() {
        return List.of(new OnAdminJoinListener());
    }
}
